(* "Knowledge/biegelinie-4.sml"
   author: Walther Neuper 190515
   (c) due to copyright terms
*)
"table of contents ---------------------------------------------------------------------------";
"---------------------------------------------------------------------------------------------";
"----------- IntegrierenUndKonstanteBestimmen2: Bsp.7.70. auto TODO investigate failure ------";
"----------- IntegrierenUndKonstanteBestimmen2: Bsp.7.70. me' with ALL subproblems -----------";
"----------- biegel Bsp.7.70. check Problem + MethodC model ----------------------------------";
"---------------------------------------------------------------------------------------------";
"---------------------------------------------------------------------------------------------";
"---------------------------------------------------------------------------------------------";


(** -------- IntegrierenUndKonstanteBestimmen2: Bsp.7.70. auto TODO investigate failure ---- **)
"----------- IntegrierenUndKonstanteBestimmen2: Bsp.7.70. auto TODO investigate failure ------";
"----------- IntegrierenUndKonstanteBestimmen2: Bsp.7.70. auto TODO investigate failure ------";
(* the error in this test might be independent from introduction of y, dy
   as arguments in IntegrierenUndKonstanteBestimmen2,
   rather due to so far untested use of "auto"
----------------------------------------------------------------------------------------------* )
val fmz = ["Traegerlaenge L", "Streckenlast q_0", "Biegelinie y",
	     "Randbedingungen [y 0 = (0::real), y L = 0, M_b 0 = 0, M_b L = 0]",
	     "FunktionsVariable x", "GleichungsVariablen [c, c_2, c_3, c_4]",
       "AbleitungBiegelinie dy"];
val (dI',pI',mI') = ("Biegelinie", ["Biegelinien"], ["IntegrierenUndKonstanteBestimmen2"]);

States.reset ();
CalcTree @{context} [(fmz, (dI',pI',mI'))];                                     
Iterator 1;
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;

val ((pt, p),_) = States.get_calc 1;
if p = ([], Pbl) then () else error ""
get_obj I pt (fst p); (*TODO investigate failure*)

(* NOTE: \<up> \<up> \<up> \<up> \<up> ^^ no progress already in isabisac15, but not noticed \<up> \<up> \<up> \<up> \<up> ^^ * )
(*[], Met*)autoCalculate 1 CompleteCalcHead;
(*[1], Pbl*)autoCalculate 1 (Steps 1); (* into SubProblem *)
(*[1], Res*)autoCalculate 1 CompleteSubpbl; (**)
(*[2], Pbl*)autoCalculate 1 (Steps 1); (* out of SubProblem *)
(*[2], Res*)autoCalculate 1 CompleteSubpbl;
(*[3], Pbl*)autoCalculate 1 (Steps 1); (* out of SubProblem *)
(*[3], Met*)autoCalculate 1 CompleteCalcHead;
(*[3, 1], Frm*)autoCalculate 1 (Steps 1); (* solve SubProblem *)
(*(**)autoCalculate 1 CompleteSubpbl;  error in kernel 4: Step.add: not impl.for Empty_Tac_*)
(*[3, 1], Res*)autoCalculate 1 (Steps 1); (* solve SubProblem *)
(*[3, 2], Res*)autoCalculate 1 (Steps 1); (* solve SubProblem *)
(*[3, 3], Res*)autoCalculate 1 (Steps 1); (* solve SubProblem *)
(*[3, 4], Res*)autoCalculate 1 (Steps 1); (* solve SubProblem *)
(*[3, 5], Res*)autoCalculate 1 (Steps 1); (* solve SubProblem *)
(*[3, 6], Res*)autoCalculate 1 (Steps 1); (* solve SubProblem *)
(*[3, 7], Res*)autoCalculate 1 (Steps 1); (* solve SubProblem *)
(*[3, 8], Pbl*)autoCalculate 1 (Steps 1); (* solve SubProblem *)
(*[3, 8], Met*)autoCalculate 1 CompleteCalcHead;
(*[3, 8, 1], Frm*)autoCalculate 1 (Steps 1); (* solve SubProblem *)
(*[3, 8, 1], Res*)autoCalculate 1 (Steps 1); (* solve SubProblem *)
(*(**)autoCalculate 1 (Steps 1); 
*** Step.add: not impl.for Empty_Tac_ 
val it = <AUTOCALC><CALCID>1</CALCID><CALCMESSAGE>helpless</CALCMESSAGE></AUTOCALC>: XML.tree *)

val ((pt,_),_) = States.get_calc 1;
val ip = States.get_pos 1 1;
val (Form f, tac, asms) = ME_Misc.pt_extract (pt, ip);

if ip = ([3, 8, 1], Res) andalso 
UnparseC.term @{context} f = "[- 1 * c_4 / - 1 = 0,\n (6 * c_4 * EI + 6 * L * c_3 * EI + -3 * L \<up> 2 * c_2 + - 1 * L \<up> 3 * c) /\n (6 * EI) =\n L \<up> 4 * q_0 / (- 24 * EI),\n c_2 = 0, c_2 + L * c = L \<up> 2 * q_0 / 2]"
then 
  case tac of
    SOME (Check_Postcond ["normalise", "4x4", "LINEAR", "system"]) => ()
  | _ => error "ERROR biegel.7.70 changed 1"
else error "ERROR biegel.7.70 changed 2";
( * NOTE: \<up> \<up> \<up> \<up> \<up> ^^ no progress already in isabisac15, but not noticed \<up> \<up> \<up> \<up> \<up> ^^ *)
----------------------------------------------------------------------------------------------*)


(** -------- IntegrierenUndKonstanteBestimmen2: Bsp.7.70. me' with ALL subproblems --------- **)
"----------- IntegrierenUndKonstanteBestimmen2: Bsp.7.70. me' with ALL subproblems -----------";
"----------- IntegrierenUndKonstanteBestimmen2: Bsp.7.70. me' with ALL subproblems -----------";

val (tac as Model_Problem (*["Biegelinien"]*), (pt, p as ([], Pbl))) =
Test_Code.init_calc' @{context} [(["Traegerlaenge L", "Streckenlast q_0", "Biegelinie y",
	    "Randbedingungen [y 0 = (0::real), y L = 0, M_b 0 = 0, M_b L = 0]",
(*
  Now follow items for ALL SubProblems,
  since ROOT MethodC must provide values for "actuals" of ALL SubProblems.
  See Biegelinie.thy subsection \<open>Survey on Methods\<close>.
*)
(*
  Items for MethodC "IntegrierenUndKonstanteBestimmen2"
*)
	    "FunktionsVariable x",
    (*"Biegelinie y",          ..already input for Problem above*)
      "AbleitungBiegelinie dy",
      "Biegemoment M_b",
      "Querkraft Q",
(*
  Item for Problem "LINEAR/system", which by [''no_met''] involves refinement
*)
      "GleichungsVariablen [c, c_2, c_3, c_4]"
],
("Biegelinie", ["Biegelinien"], ["IntegrierenUndKonstanteBestimmen2"]))]

(* 
  Legend:
  the indentation follows subsection \<open>Survey on Methods\<close> in Biegelinie.thy.
  The structure of the calculation below is made explicit in the following way:

  |create I_Model of root Problem from Formalise.model
  |check 3 Formalise.refs
  |create I_Model of root MethodC, ending by Apply_Method 

    |create I_Model of SubProblem from arguments, given values by the Program of the root
    |check 3 Formalise.refs
    |create I_Model of SubProblem's MethodC, ending either by
    |  Apply_Method of respective SubProblem
    |  or
    |  Check_Postcond of Problem and return to respective parent

  Note: Programs immediately calling a SubProblem, does (not yet) indicate
    this SubProblem as separate Step.
*)

  val (tac as Apply_Method ["IntegrierenUndKonstanteBestimmen2"], (pt, p as ([], Met))) =
  (tac, (pt, p)) |> me' |> me' |> me' |> me' |> me' |> me' |> me' |> me' |> me' |> me'
  (*---broken elementwise input to lists---* ) |> me' ( *---broken elementwise input to lists---*)
  |> me' |> me' |> me'

    (*INVISIBLE: tac as SubProblem (''Biegelinie'', [''vonBelastungZu'', ''Biegelinien''])*)
    val (tac as Apply_Method ["Biegelinien", "ausBelastung"], (pt, p as ([1], Met))) =
    (tac, (pt, p)) |> me' |> me' |> me' |> me' |> me' |> me' |> me' |> me' |> me' |> me' |> me' 
    |> me'
    val (tac as Subproblem ("Biegelinie", ["named", "integrate", "function"]), (pt, p as ([1, 2], Res))) =
    (tac, (pt, p)) |> me' |> me' |> me'

      val (tac as Apply_Method ["diff", "integration", "named"], (pt, p as ([1, 3], Met))) =
      (tac, (pt, p)) |> me' |> me' |> me' |> me' |> me' |> me' |> me' |> me'
      val (tac as Check_Postcond ["named", "integrate", "function"], (pt, p)) =
      (tac, (pt, p)) |> me' |> me' |> me'

    val (tac as Subproblem ("Biegelinie", ["named", "integrate", "function"]), (pt, p as ([1, 4], Res))) =
    (tac, (pt, p)) |> me' |> me'

      val (tac as Apply_Method ["diff", "integration", "named"], (pt, p as ([1, 5], Met))) =
      (tac, (pt, p)) |> me' |> me' |> me' |> me' |> me' |> me' |> me' |> me'
      val (tac as Check_Postcond ["named", "integrate", "function"], (pt, p as ([1, 5, 1], Res))) =
      (tac, (pt, p)) |> me' |> me'

    val (tac as Subproblem ("Biegelinie", ["named", "integrate", "function"]), (pt, p as ([1, 7], Res))) =
    (tac, (pt, p)) |> me' |> me' |> me'

      val (tac as Apply_Method ["diff", "integration", "named"], (pt, p as ([1, 8], Met))) =
      (tac, (pt, p)) |> me' |> me' |> me' |> me' |> me' |> me' |> me' |> me'
      val (tac as Check_Postcond ["named", "integrate", "function"], (pt, p as ([1, 8, 2], Res))) =
      (tac, (pt, p)) |> me' |> me' |> me'

    val (tac as Subproblem ("Biegelinie", ["named", "integrate", "function"]), (pt, p)) =
    (tac, (pt, p)) |> me'

      val (tac as Apply_Method ["diff", "integration", "named"], (pt, p as ([1, 9], Met))) =
      (tac, (pt, p)) |> me' |> me' |> me' |> me' |> me' |> me' |> me' |> me'
      val (tac as Check_Postcond ["named", "integrate", "function"], (pt, p)) =
      (tac, (pt, p)) |> me' |> me'

    val (tac as Check_Postcond ["vonBelastungZu", "Biegelinien"], (pt, p as ([1, 9], Res))) =
    (tac, (pt, p)) |> me'

  val (tac as Subproblem ("Biegelinie", ["setzeRandbedingungen", "Biegelinien"]), (pt, p as ([1], Res))) =
  (tac, (pt, p)) |> me'

    val (tac as Apply_Method ["Biegelinien", "setzeRandbedingungenEin"], (pt, p as ([2], Met))) =
    (tac, (pt, p)) |> me' |> me' |> me' |> me' |> me' |> me' |> me' |> me'

      (*INVISIBLE: tac as SubProblem (''Biegelinie'', [''makeFunctionTo'', ''equation''])*)
      val (tac as Apply_Method ["Equation", "fromFunction"], (pt, p as ([2, 1], Met))) =
      (tac, (pt, p)) |> me' |> me' |> me' |> me' |> me' |> me' |> me' |> me'
      val (tac as Check_Postcond ["makeFunctionTo", "equation"], (pt, p)) =
      (tac, (pt, p)) |> me' |> me' |> me' |> me'

    val (tac as Subproblem ("Biegelinie", ["makeFunctionTo", "equation"]), (pt, p as ([2, 1], Res))) =
    (tac, (pt, p)) |> me'
val "0 = - 1 * c_4 / - 1" = Calc.current_formula (pt, p) |> UnparseC.term @{context};
(*--^^^^^^^^^^^^^^^^^^^^^ requires improved simplification*)

(** -------- biegel Bsp.7.70. check Problem + MethodC model -------------------------------- **)
"----------- biegel Bsp.7.70. check Problem + MethodC model ----------------------------------";
"----------- biegel Bsp.7.70. check Problem + MethodC model ----------------------------------";
(*this formalisation contains no variants, as opposed to maximum example*)
val (tac as Model_Problem (*["Biegelinien"]*), ptp as (pt, p as ([], Pbl))) =
Test_Code.init_calc' @{context} [(["Traegerlaenge L", "Streckenlast q_0", "Biegelinie y",
	    "Randbedingungen [y 0 = (0::real), y L = 0, M_b 0 = 0, M_b L = 0]",
(*
  Now follow items for ALL SubProblems,
  since ROOT MethodC must provide values for "actuals" of ALL SubProblems.
  See Biegelinie.thy subsection \<open>Survey on Methods\<close>.
*)
(*
  Items for MethodC "IntegrierenUndKonstanteBestimmen2"
*)
	    "FunktionsVariable x",
    (*"Biegelinie y",          ..already input for Problem above*)
      "AbleitungBiegelinie dy",
      "Biegemoment M_b",
      "Querkraft Q",
(*
  Item for Problem "LINEAR/system", which by [''no_met''] involves refinement
*)
      "GleichungsVariablen [c, c_2, c_3, c_4]"
],
("Biegelinie", ["Biegelinien"], ["IntegrierenUndKonstanteBestimmen2"]))]

(*** stepwise Specification: Problem model================================================= ***)
val ("ok", ([(Model_Problem, _, _)], _, ptp))
  = Step.specify_do_next ptp;
val ("ok", ([(Add_Given "Traegerlaenge L", _, _)], _, ptp))
  = Step.specify_do_next ptp;
val ("ok", ([(Add_Given "Streckenlast q_0", _, _)], _, ptp))
  = Step.specify_do_next ptp;
val ("ok", ([(Add_Find "Biegelinie y", _, _)], _, ptp))
  = Step.specify_do_next ptp;
val ("ok", ([(Add_Relation "Randbedingungen [y 0 = 0]", _, _)], _, ptp))
  = Step.specify_do_next ptp;
val ("ok", ([(Add_Relation "Randbedingungen [y L = 0, M_b 0 = 0, M_b L = 0]", _, _)], _, ptp))
  = Step.specify_do_next ptp;

(*** Problem model is complete ============================================================ ***)
val PblObj {probl, ...} = get_obj I (fst ptp) [];
(*WN230827 adaptation too time consuming* )
if I_Model.to_string @{context} probl = "[\n" ^
  "(1 ,[1] ,true ,#Given ,Cor Traegerlaenge L ,(l_l, [L])), \n" ^
  "(2 ,[1] ,true ,#Given ,Cor Streckenlast q_0 ,(q_q, [q_0])), \n" ^
  "(3 ,[1] ,true ,#Find ,Cor Biegelinie y ,(b_b, [y])), \n" ^
  "(4 ,[1] ,true ,#Relate ,Cor Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0] ,(r_b, [[y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]]))]"
then () else error "I_Model.to_string probl CHANGED";
( *WN230827 adaptation too time consuming*)

(*** Specification of References ========================================================== ***)
val ("ok", ([(Specify_Theory "Biegelinie", _, _)], _, ptp))
  = Step.specify_do_next ptp;
val ("ok", ([(Specify_Problem ["Biegelinien"], _, _)], _, ptp))
  = Step.specify_do_next ptp;
val ("ok", ([(Specify_Method ["IntegrierenUndKonstanteBestimmen2"], _, _)], _, ptp))
  = Step.specify_do_next ptp;

(*** stepwise Specification: MethodC model ================================================ ***)
val ("ok", ([(Add_Given "FunktionsVariable x", _, _)], _, ptp))
  = Step.specify_do_next ptp;
val ("ok", ([(Add_Given "AbleitungBiegelinie dy", _, _)], _, ptp))
  = Step.specify_do_next ptp;
val ("ok", ([(Add_Given "Biegemoment M_b", _, _)], _, ptp))
  = Step.specify_do_next ptp;
val ("ok", ([(Add_Given "Querkraft Q", _, _)], _, ptp))
  = Step.specify_do_next ptp;
val ("ok", ([(Add_Given "GleichungsVariablen [c, c_2, c_3, c_4]", _, _)], _, ptp))
  = Step.specify_do_next ptp;

(*** Specification of Problem and MethodC model is completes ============================== ***)
val PblObj {meth, ...} = get_obj I (fst ptp) [];
if I_Model.to_string @{context} meth = "[\n" ^
  "(1 ,[1] ,true ,#Given ,Cor Traegerlaenge L , pen2str), \n" ^
  "(2 ,[1] ,true ,#Given ,Cor Streckenlast q_0 , pen2str), \n" ^
  "(3 ,[1] ,true ,#Find ,Cor Biegelinie y , pen2str), \n" ^
  "(4 ,[1] ,true ,#Relate ,Cor Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0] , pen2str), \n" ^
  "(5 ,[1] ,true ,#Given ,Cor FunktionsVariable x , pen2str), \n" ^
  "(6 ,[1] ,true ,#Given ,Cor AbleitungBiegelinie dy , pen2str), \n" ^
  "(7 ,[1] ,true ,#Given ,Cor Biegemoment M_b , pen2str), \n" ^
  "(8 ,[1] ,true ,#Given ,Cor Querkraft Q , pen2str), \n" ^
  "(9 ,[1] ,true ,#Given ,Cor GleichungsVariablen [c, c_2, c_3, c_4] , pen2str)]"
then () else error "I_Model.to_string meth CHANGED";

(*** Solution starts ====================================================================== ***)
val ("ok", ([(Apply_Method ["IntegrierenUndKonstanteBestimmen2"], _, _)], _, ptp))
  = Step.specify_do_next ptp;
