
theory integrate
imports Isac.Build_Thydata
begin

ML \<open>
"----------- method analog to rls 'integration' ---------";
"----------- method analog to rls 'integration' ---------";
"----------- method analog to rls 'integration' ---------";
\<close>
partial_function (tailrec) integration_test :: "real \<Rightarrow> real \<Rightarrow> real"
  where
"integration_test f_f v_v =
  (((Rewrite_Set_Inst [(''bdv'',v_v)] ''integration_rules'') #>
    (Rewrite_Set_Inst [(''bdv'',v_v)] ''add_new_c'')         #>
    (Rewrite_Set_Inst [(''bdv'',v_v)] ''simplify_Integral'')) (f_f::real))"
ML \<open>
(*/----- local in struct Problem -------------\*)
val drop_pos_model = (fn (a, b, _) => (a, b))
val drop_pos_where_ = (fn (b, _) => b)
(*\----- local in struct Problem -------------/*)
val model_input = [("#Given", [("functionTerm f_f", Position.none),
                               ("integrateBy v_v", Position.none)]),
                   ("#Find", [("antiDerivative F_F", Position.none)])]
(* cp from method.sml, Outer_Syntax.command \<^command_keyword>\<open>method\<close> *)
          val thy = @{theory}
          val ctxt = Proof_Context.init_global thy
          val (model, where_) = Model_Pattern.parse_pos ctxt model_input
          val (model', where_') = (map drop_pos_model model, map drop_pos_where_ where_)
          val ml_input =
            {rew_ord = "sqrt_right", rls'= tval_rls, prog_rls = Rule_Set.empty, where_rls = Rule_Set.empty,
            calc = [], errpats = [], rew_rls = Rule_Set.empty} : MethodC.ml_input
          val thm = @{thm integration_test.simps}
          val arg = MethodC.prep_store thy "met_testint" [] Problem.id_empty
            (["diff", "integration", "test"], model', where_', ml_input, thm)
\<close> 
setup \<open>Know_Store.add_mets @{context} [arg]\<close>

end
